/* dialogs.c generated by valac 0.56.17, the Vala compiler
 * generated from dialogs.vala, do not modify */

/* dialogs.vala
 *
 * Copyright (C) Red Hat, Inc
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author: Marek Kasik <mkasik@redhat.com>
 *
 */

#include <handy.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define CONNECTIONS_TYPE_DIALOGS_WINDOW (connections_dialogs_window_get_type ())
#define CONNECTIONS_DIALOGS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONNECTIONS_TYPE_DIALOGS_WINDOW, ConnectionsDialogsWindow))
#define CONNECTIONS_DIALOGS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONNECTIONS_TYPE_DIALOGS_WINDOW, ConnectionsDialogsWindowClass))
#define CONNECTIONS_IS_DIALOGS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONNECTIONS_TYPE_DIALOGS_WINDOW))
#define CONNECTIONS_IS_DIALOGS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONNECTIONS_TYPE_DIALOGS_WINDOW))
#define CONNECTIONS_DIALOGS_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONNECTIONS_TYPE_DIALOGS_WINDOW, ConnectionsDialogsWindowClass))

typedef struct _ConnectionsDialogsWindow ConnectionsDialogsWindow;
typedef struct _ConnectionsDialogsWindowClass ConnectionsDialogsWindowClass;
typedef struct _ConnectionsDialogsWindowPrivate ConnectionsDialogsWindowPrivate;
typedef void (*ConnectionsDialogsWindowCertificateVerifyFunc) (gboolean verified, gpointer user_data);
typedef void (*ConnectionsDialogsWindowCertificateChangeVerifyFunc) (gboolean verified, gpointer user_data);
typedef void (*ConnectionsDialogsWindowAuthenticationFunc) (const gchar* username, const gchar* password, const gchar* domain, gpointer user_data);
enum  {
	CONNECTIONS_DIALOGS_WINDOW_0_PROPERTY,
	CONNECTIONS_DIALOGS_WINDOW_NUM_PROPERTIES
};
static GParamSpec* connections_dialogs_window_properties[CONNECTIONS_DIALOGS_WINDOW_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _ConnectionsDialogsWindow {
	HdyWindow parent_instance;
	ConnectionsDialogsWindowPrivate * priv;
	GtkStack* content_stack;
	GtkStack* header_stack;
};

struct _ConnectionsDialogsWindowClass {
	HdyWindowClass parent_class;
};

struct _ConnectionsDialogsWindowPrivate {
	gboolean change_verification;
	gchar* certificate_fingerprint;
	gchar* connection_name;
	gboolean certificate_verification_show_flag;
	gboolean certificate_change_verification_show_flag;
	gboolean authentication_show_flag;
	gboolean need_username;
	gboolean need_password;
	gboolean need_domain;
	GtkLabel* text_label;
	GtkLabel* fingerprint_value;
	GtkLabel* certificate_change_text_label;
	GtkButton* connect_button;
	GtkSwitch* delete_local_certificate_switch;
	GtkImage* show_password_icon;
	GtkEntry* username_entry;
	GtkEntry* password_entry;
	GtkEntry* domain_entry;
	GtkLabel* authentication_text;
	HdyHeaderBar* dialog_headerbar;
	HdyActionRow* username_row;
	HdyActionRow* password_row;
	HdyActionRow* domain_row;
	GMutex mutex;
	ConnectionsDialogsWindowCertificateVerifyFunc certificate_verify_func;
	gpointer certificate_verify_func_target;
	GDestroyNotify certificate_verify_func_target_destroy_notify;
	ConnectionsDialogsWindowCertificateChangeVerifyFunc certificate_change_verify_func;
	gpointer certificate_change_verify_func_target;
	GDestroyNotify certificate_change_verify_func_target_destroy_notify;
	ConnectionsDialogsWindowAuthenticationFunc authentication_func;
	gpointer authentication_func_target;
	GDestroyNotify authentication_func_target_destroy_notify;
};

static gint ConnectionsDialogsWindow_private_offset;
static gpointer connections_dialogs_window_parent_class = NULL;

VALA_EXTERN GType connections_dialogs_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ConnectionsDialogsWindow, g_object_unref)
static gboolean connections_dialogs_window_check_show_flags (ConnectionsDialogsWindow* self);
static void connections_dialogs_window_show_certificate_verification_real (ConnectionsDialogsWindow* self);
VALA_EXTERN void connections_dialogs_window_show_certificate_change_verification_real (ConnectionsDialogsWindow* self);
VALA_EXTERN void connections_dialogs_window_show_authentication_real (ConnectionsDialogsWindow* self);
static gchar* connections_dialogs_window_split_fingerprint (ConnectionsDialogsWindow* self,
                                                     const gchar* fingerprint);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN void connections_dialogs_window_show_certificate_verification (ConnectionsDialogsWindow* self,
                                                               const gchar* name,
                                                               const gchar* fingerprint,
                                                               ConnectionsDialogsWindowCertificateVerifyFunc certificate_verify_func_in,
                                                               gpointer certificate_verify_func_in_target,
                                                               GDestroyNotify certificate_verify_func_in_target_destroy_notify);
VALA_EXTERN void connections_dialogs_window_show_certificate_change_verification (ConnectionsDialogsWindow* self,
                                                                      const gchar* name,
                                                                      const gchar* fingerprint,
                                                                      ConnectionsDialogsWindowCertificateChangeVerifyFunc certificate_change_verify_func_in,
                                                                      gpointer certificate_change_verify_func_in_target,
                                                                      GDestroyNotify certificate_change_verify_func_in_target_destroy_notify);
VALA_EXTERN void connections_dialogs_window_show_authentication (ConnectionsDialogsWindow* self,
                                                     const gchar* name,
                                                     gboolean need_username_in,
                                                     gboolean need_password_in,
                                                     gboolean need_domain_in,
                                                     ConnectionsDialogsWindowAuthenticationFunc authentication_func_in,
                                                     gpointer authentication_func_in_target,
                                                     GDestroyNotify authentication_func_in_target_destroy_notify);
static void connections_dialogs_window_cancel_connection (ConnectionsDialogsWindow* self);
static void connections_dialogs_window_dismiss (ConnectionsDialogsWindow* self);
static void _connections_dialogs_window_cancel_connection_gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self);
static void connections_dialogs_window_verify_button_clicked_cb (ConnectionsDialogsWindow* self);
static void _connections_dialogs_window_verify_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                              gpointer self);
static void connections_dialogs_window_connect_button_clicked_cb (ConnectionsDialogsWindow* self);
static void _connections_dialogs_window_connect_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                               gpointer self);
static void connections_dialogs_window_delete_local_certificate_switch_changed (ConnectionsDialogsWindow* self);
static void _connections_dialogs_window_delete_local_certificate_switch_changed_g_object_notify (GObject* _sender,
                                                                                          GParamSpec* pspec,
                                                                                          gpointer self);
static gboolean connections_dialogs_window_on_key_pressed (ConnectionsDialogsWindow* self,
                                                    GtkWidget* widget,
                                                    GdkEventKey* event);
static gboolean _connections_dialogs_window_on_key_pressed_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                                GdkEventKey* event,
                                                                                gpointer self);
static void connections_dialogs_window_show_password_button_clicked (ConnectionsDialogsWindow* self);
static void _connections_dialogs_window_show_password_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                  gpointer self);
static void connections_dialogs_window_cancel_authentication_clicked (ConnectionsDialogsWindow* self);
static void _connections_dialogs_window_cancel_authentication_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                   gpointer self);
static void connections_dialogs_window_authenticate_button_clicked (ConnectionsDialogsWindow* self);
static void _connections_dialogs_window_authenticate_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                 gpointer self);
static void connections_dialogs_window_on_username_entry_activated (ConnectionsDialogsWindow* self);
static void _connections_dialogs_window_on_username_entry_activated_gtk_entry_activate (GtkEntry* _sender,
                                                                                 gpointer self);
static void connections_dialogs_window_on_password_entry_activated (ConnectionsDialogsWindow* self);
static void _connections_dialogs_window_on_password_entry_activated_gtk_entry_activate (GtkEntry* _sender,
                                                                                 gpointer self);
static void connections_dialogs_window_on_domain_entry_activated (ConnectionsDialogsWindow* self);
static void _connections_dialogs_window_on_domain_entry_activated_gtk_entry_activate (GtkEntry* _sender,
                                                                               gpointer self);
static gboolean connections_dialogs_window_hide_when_delete (ConnectionsDialogsWindow* self);
VALA_EXTERN ConnectionsDialogsWindow* connections_dialogs_window_new (void);
VALA_EXTERN ConnectionsDialogsWindow* connections_dialogs_window_construct (GType object_type);
static GObject * connections_dialogs_window_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
static gboolean _connections_dialogs_window_check_show_flags_gsource_func (gpointer self);
static gboolean _connections_dialogs_window_hide_when_delete_gtk_widget_delete_event (GtkWidget* _sender,
                                                                               GdkEventAny* event,
                                                                               gpointer self);
static void connections_dialogs_window_finalize (GObject * obj);
static GType connections_dialogs_window_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static void _vala_clear_GMutex (GMutex * mutex);
static void _vala_clear_GRecMutex (GRecMutex * mutex);
static void _vala_clear_GRWLock (GRWLock * mutex);
static void _vala_clear_GCond (GCond * mutex);

static inline gpointer
connections_dialogs_window_get_instance_private (ConnectionsDialogsWindow* self)
{
	return G_STRUCT_MEMBER_P (self, ConnectionsDialogsWindow_private_offset);
}

static gboolean
connections_dialogs_window_check_show_flags (ConnectionsDialogsWindow* self)
{
	gboolean scvf = FALSE;
	gboolean sccvf = FALSE;
	gboolean saf = FALSE;
	gboolean result;
#line 111 "../src/dialogs.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 114 "../src/dialogs.vala"
	g_mutex_lock (&self->priv->mutex);
#line 116 "../src/dialogs.vala"
	scvf = self->priv->certificate_verification_show_flag;
#line 117 "../src/dialogs.vala"
	if (self->priv->certificate_verification_show_flag) {
#line 118 "../src/dialogs.vala"
		self->priv->certificate_verification_show_flag = FALSE;
#line 242 "dialogs.c"
	}
#line 120 "../src/dialogs.vala"
	sccvf = self->priv->certificate_change_verification_show_flag;
#line 121 "../src/dialogs.vala"
	if (self->priv->certificate_change_verification_show_flag) {
#line 122 "../src/dialogs.vala"
		self->priv->certificate_change_verification_show_flag = FALSE;
#line 250 "dialogs.c"
	}
#line 124 "../src/dialogs.vala"
	saf = self->priv->authentication_show_flag;
#line 125 "../src/dialogs.vala"
	if (self->priv->authentication_show_flag) {
#line 126 "../src/dialogs.vala"
		self->priv->authentication_show_flag = FALSE;
#line 258 "dialogs.c"
	}
#line 128 "../src/dialogs.vala"
	g_mutex_unlock (&self->priv->mutex);
#line 130 "../src/dialogs.vala"
	if (scvf) {
#line 131 "../src/dialogs.vala"
		connections_dialogs_window_show_certificate_verification_real (self);
#line 266 "dialogs.c"
	}
#line 134 "../src/dialogs.vala"
	if (sccvf) {
#line 135 "../src/dialogs.vala"
		connections_dialogs_window_show_certificate_change_verification_real (self);
#line 272 "dialogs.c"
	}
#line 138 "../src/dialogs.vala"
	if (saf) {
#line 139 "../src/dialogs.vala"
		connections_dialogs_window_show_authentication_real (self);
#line 278 "dialogs.c"
	}
#line 142 "../src/dialogs.vala"
	result = TRUE;
#line 142 "../src/dialogs.vala"
	return result;
#line 284 "dialogs.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 298 "dialogs.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 302 "dialogs.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 308 "dialogs.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 313 "dialogs.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 319 "dialogs.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 323 "dialogs.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 327 "dialogs.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 331 "dialogs.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 335 "dialogs.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 339 "dialogs.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 354 "dialogs.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 363 "dialogs.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 370 "dialogs.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 376 "dialogs.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 384 "dialogs.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 388 "dialogs.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 394 "dialogs.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 399 "dialogs.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 405 "dialogs.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 409 "dialogs.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 413 "dialogs.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 419 "dialogs.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 425 "dialogs.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 437 "dialogs.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 441 "dialogs.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 445 "dialogs.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 450 "dialogs.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 458 "dialogs.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 476 "dialogs.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 482 "dialogs.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 486 "dialogs.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 494 "dialogs.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 503 "dialogs.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 512 "dialogs.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 518 "dialogs.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 526 "dialogs.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 538 "dialogs.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 544 "dialogs.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 548 "dialogs.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 556 "dialogs.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 567 "dialogs.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 576 "dialogs.c"
	}
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 151 "../src/dialogs.vala"
	if ((*length) == (*size)) {
#line 151 "../src/dialogs.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 151 "../src/dialogs.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 592 "dialogs.c"
	}
#line 151 "../src/dialogs.vala"
	(*array)[(*length)++] = value;
#line 151 "../src/dialogs.vala"
	(*array)[*length] = NULL;
#line 598 "dialogs.c"
}

static gchar*
connections_dialogs_window_split_fingerprint (ConnectionsDialogsWindow* self,
                                              const gchar* fingerprint)
{
	gchar** fp = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint fp_length1;
	gint _fp_size_;
	gchar** tmpv = NULL;
	gchar** _tmp2_;
	gint tmpv_length1;
	gint _tmpv_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar* result;
#line 145 "../src/dialogs.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 145 "../src/dialogs.vala"
	g_return_val_if_fail (fingerprint != NULL, NULL);
#line 146 "../src/dialogs.vala"
	_tmp1_ = _tmp0_ = g_strsplit (fingerprint, ":", 0);
#line 146 "../src/dialogs.vala"
	fp = _tmp1_;
#line 146 "../src/dialogs.vala"
	fp_length1 = _vala_array_length (_tmp0_);
#line 146 "../src/dialogs.vala"
	_fp_size_ = fp_length1;
#line 147 "../src/dialogs.vala"
	_tmp2_ = g_new0 (gchar*, 0 + 1);
#line 147 "../src/dialogs.vala"
	tmpv = _tmp2_;
#line 147 "../src/dialogs.vala"
	tmpv_length1 = 0;
#line 147 "../src/dialogs.vala"
	_tmpv_size_ = tmpv_length1;
#line 149 "../src/dialogs.vala"
	_tmp3_ = fp;
#line 149 "../src/dialogs.vala"
	_tmp3__length1 = fp_length1;
#line 149 "../src/dialogs.vala"
	if (_tmp3__length1 == 32) {
#line 643 "dialogs.c"
		gchar* fp2 = NULL;
		gchar** _tmp15_;
		gint _tmp15__length1;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		{
			gint i = 0;
#line 150 "../src/dialogs.vala"
			i = 0;
#line 655 "dialogs.c"
			{
				gboolean _tmp4_ = FALSE;
#line 150 "../src/dialogs.vala"
				_tmp4_ = TRUE;
#line 150 "../src/dialogs.vala"
				while (TRUE) {
#line 662 "dialogs.c"
					gchar** _tmp6_;
					gint _tmp6__length1;
					gchar* _tmp7_;
					gchar* _tmp8_;
					gchar* _tmp9_;
					gchar* _tmp10_;
					gchar** _tmp11_;
					gint _tmp11__length1;
					gchar* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
#line 150 "../src/dialogs.vala"
					if (!_tmp4_) {
#line 676 "dialogs.c"
						gint _tmp5_;
#line 150 "../src/dialogs.vala"
						_tmp5_ = i;
#line 150 "../src/dialogs.vala"
						i = _tmp5_ + 1;
#line 682 "dialogs.c"
					}
#line 150 "../src/dialogs.vala"
					_tmp4_ = FALSE;
#line 150 "../src/dialogs.vala"
					if (!(i < 4)) {
#line 150 "../src/dialogs.vala"
						break;
#line 690 "dialogs.c"
					}
#line 151 "../src/dialogs.vala"
					_tmp6_ = fp;
#line 151 "../src/dialogs.vala"
					_tmp6__length1 = fp_length1;
#line 151 "../src/dialogs.vala"
					_tmp7_ = _vala_g_strjoinv (":", _tmp6_ + (i * 8), (gint) (((i * 8) + 4) - (i * 8)));
#line 151 "../src/dialogs.vala"
					_tmp8_ = _tmp7_;
#line 151 "../src/dialogs.vala"
					_tmp9_ = g_strconcat (_tmp8_, "   ", NULL);
#line 151 "../src/dialogs.vala"
					_tmp10_ = _tmp9_;
#line 151 "../src/dialogs.vala"
					_tmp11_ = fp;
#line 151 "../src/dialogs.vala"
					_tmp11__length1 = fp_length1;
#line 151 "../src/dialogs.vala"
					_tmp12_ = _vala_g_strjoinv (":", _tmp11_ + ((i * 8) + 4), (gint) (((i * 8) + 8) - ((i * 8) + 4)));
#line 151 "../src/dialogs.vala"
					_tmp13_ = _tmp12_;
#line 151 "../src/dialogs.vala"
					_tmp14_ = g_strconcat (_tmp10_, _tmp13_, NULL);
#line 151 "../src/dialogs.vala"
					_vala_array_add1 (&tmpv, &tmpv_length1, &_tmpv_size_, _tmp14_);
#line 151 "../src/dialogs.vala"
					_g_free0 (_tmp13_);
#line 151 "../src/dialogs.vala"
					_g_free0 (_tmp10_);
#line 151 "../src/dialogs.vala"
					_g_free0 (_tmp8_);
#line 722 "dialogs.c"
				}
			}
		}
#line 153 "../src/dialogs.vala"
		_tmp15_ = tmpv;
#line 153 "../src/dialogs.vala"
		_tmp15__length1 = tmpv_length1;
#line 153 "../src/dialogs.vala"
		_tmp16_ = _vala_g_strjoinv ("\n", _tmp15_, (gint) _tmp15__length1);
#line 153 "../src/dialogs.vala"
		_tmp17_ = _tmp16_;
#line 153 "../src/dialogs.vala"
		_tmp18_ = g_utf8_strup (_tmp17_, (gssize) -1);
#line 153 "../src/dialogs.vala"
		_tmp19_ = _tmp18_;
#line 153 "../src/dialogs.vala"
		_g_free0 (_tmp17_);
#line 153 "../src/dialogs.vala"
		fp2 = _tmp19_;
#line 155 "../src/dialogs.vala"
		result = fp2;
#line 155 "../src/dialogs.vala"
		tmpv = (_vala_array_free (tmpv, tmpv_length1, (GDestroyNotify) g_free), NULL);
#line 155 "../src/dialogs.vala"
		fp = (_vala_array_free (fp, fp_length1, (GDestroyNotify) g_free), NULL);
#line 155 "../src/dialogs.vala"
		return result;
#line 750 "dialogs.c"
	} else {
		gchar* _tmp20_;
#line 157 "../src/dialogs.vala"
		_tmp20_ = g_strdup ("");
#line 157 "../src/dialogs.vala"
		result = _tmp20_;
#line 157 "../src/dialogs.vala"
		tmpv = (_vala_array_free (tmpv, tmpv_length1, (GDestroyNotify) g_free), NULL);
#line 157 "../src/dialogs.vala"
		fp = (_vala_array_free (fp, fp_length1, (GDestroyNotify) g_free), NULL);
#line 157 "../src/dialogs.vala"
		return result;
#line 763 "dialogs.c"
	}
}

static void
connections_dialogs_window_show_certificate_verification_real (ConnectionsDialogsWindow* self)
{
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkLabel* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GtkStack* _tmp8_;
	GtkStack* _tmp9_;
	GtkStack* _tmp10_;
	GtkStack* _tmp11_;
	HdyHeaderBar* _tmp12_;
#line 164 "../src/dialogs.vala"
	g_return_if_fail (self != NULL);
#line 165 "../src/dialogs.vala"
	g_mutex_lock (&self->priv->mutex);
#line 167 "../src/dialogs.vala"
	_tmp0_ = self->priv->text_label;
#line 167 "../src/dialogs.vala"
	_tmp1_ = self->priv->connection_name;
#line 167 "../src/dialogs.vala"
	_tmp2_ = g_strdup_printf (_ ("Connecting to “%s” for the first time. To be sure you're connecting to" \
" the machine it claims to be, please verify the fingerprints match. Th" \
"is process is only done once."), _tmp1_);
#line 167 "../src/dialogs.vala"
	_tmp3_ = _tmp2_;
#line 167 "../src/dialogs.vala"
	gtk_label_set_label (_tmp0_, _tmp3_);
#line 167 "../src/dialogs.vala"
	_g_free0 (_tmp3_);
#line 169 "../src/dialogs.vala"
	_tmp4_ = self->priv->fingerprint_value;
#line 169 "../src/dialogs.vala"
	_tmp5_ = self->priv->certificate_fingerprint;
#line 169 "../src/dialogs.vala"
	_tmp6_ = connections_dialogs_window_split_fingerprint (self, _tmp5_);
#line 169 "../src/dialogs.vala"
	_tmp7_ = _tmp6_;
#line 169 "../src/dialogs.vala"
	gtk_label_set_label (_tmp4_, _tmp7_);
#line 169 "../src/dialogs.vala"
	_g_free0 (_tmp7_);
#line 171 "../src/dialogs.vala"
	g_mutex_unlock (&self->priv->mutex);
#line 173 "../src/dialogs.vala"
	_tmp8_ = self->content_stack;
#line 173 "../src/dialogs.vala"
	gtk_stack_set_visible_child_name (_tmp8_, "certificate-verification");
#line 174 "../src/dialogs.vala"
	_tmp9_ = self->header_stack;
#line 174 "../src/dialogs.vala"
	gtk_stack_set_visible_child_name (_tmp9_, "verify-button-page");
#line 175 "../src/dialogs.vala"
	_tmp10_ = self->content_stack;
#line 175 "../src/dialogs.vala"
	gtk_widget_show ((GtkWidget*) _tmp10_);
#line 176 "../src/dialogs.vala"
	_tmp11_ = self->header_stack;
#line 176 "../src/dialogs.vala"
	gtk_widget_show ((GtkWidget*) _tmp11_);
#line 177 "../src/dialogs.vala"
	_tmp12_ = self->priv->dialog_headerbar;
#line 177 "../src/dialogs.vala"
	gtk_widget_show ((GtkWidget*) _tmp12_);
#line 178 "../src/dialogs.vala"
	gtk_window_present ((GtkWindow*) self);
#line 835 "dialogs.c"
}

void
connections_dialogs_window_show_certificate_verification (ConnectionsDialogsWindow* self,
                                                          const gchar* name,
                                                          const gchar* fingerprint,
                                                          ConnectionsDialogsWindowCertificateVerifyFunc certificate_verify_func_in,
                                                          gpointer certificate_verify_func_in_target,
                                                          GDestroyNotify certificate_verify_func_in_target_destroy_notify)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 182 "../src/dialogs.vala"
	g_return_if_fail (self != NULL);
#line 182 "../src/dialogs.vala"
	g_return_if_fail (name != NULL);
#line 182 "../src/dialogs.vala"
	g_return_if_fail (fingerprint != NULL);
#line 185 "../src/dialogs.vala"
	g_mutex_lock (&self->priv->mutex);
#line 187 "../src/dialogs.vala"
	self->priv->change_verification = FALSE;
#line 188 "../src/dialogs.vala"
	_tmp0_ = g_strdup (name);
#line 188 "../src/dialogs.vala"
	_g_free0 (self->priv->connection_name);
#line 188 "../src/dialogs.vala"
	self->priv->connection_name = _tmp0_;
#line 189 "../src/dialogs.vala"
	_tmp1_ = g_strdup (fingerprint);
#line 189 "../src/dialogs.vala"
	_g_free0 (self->priv->certificate_fingerprint);
#line 189 "../src/dialogs.vala"
	self->priv->certificate_fingerprint = _tmp1_;
#line 190 "../src/dialogs.vala"
	(self->priv->certificate_verify_func_target_destroy_notify == NULL) ? NULL : (self->priv->certificate_verify_func_target_destroy_notify (self->priv->certificate_verify_func_target), NULL);
#line 190 "../src/dialogs.vala"
	self->priv->certificate_verify_func = NULL;
#line 190 "../src/dialogs.vala"
	self->priv->certificate_verify_func_target = NULL;
#line 190 "../src/dialogs.vala"
	self->priv->certificate_verify_func_target_destroy_notify = NULL;
#line 190 "../src/dialogs.vala"
	self->priv->certificate_verify_func = certificate_verify_func_in;
#line 190 "../src/dialogs.vala"
	self->priv->certificate_verify_func_target = certificate_verify_func_in_target;
#line 190 "../src/dialogs.vala"
	self->priv->certificate_verify_func_target_destroy_notify = NULL;
#line 191 "../src/dialogs.vala"
	self->priv->certificate_verification_show_flag = TRUE;
#line 193 "../src/dialogs.vala"
	g_mutex_unlock (&self->priv->mutex);
#line 182 "../src/dialogs.vala"
	(certificate_verify_func_in_target_destroy_notify == NULL) ? NULL : (certificate_verify_func_in_target_destroy_notify (certificate_verify_func_in_target), NULL);
#line 182 "../src/dialogs.vala"
	certificate_verify_func_in = NULL;
#line 182 "../src/dialogs.vala"
	certificate_verify_func_in_target = NULL;
#line 182 "../src/dialogs.vala"
	certificate_verify_func_in_target_destroy_notify = NULL;
#line 896 "dialogs.c"
}

void
connections_dialogs_window_show_certificate_change_verification_real (ConnectionsDialogsWindow* self)
{
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkLabel* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GtkStack* _tmp8_;
	GtkStack* _tmp9_;
	GtkStack* _tmp10_;
	GtkStack* _tmp11_;
	HdyHeaderBar* _tmp12_;
#line 198 "../src/dialogs.vala"
	g_return_if_fail (self != NULL);
#line 199 "../src/dialogs.vala"
	g_mutex_lock (&self->priv->mutex);
#line 201 "../src/dialogs.vala"
	_tmp0_ = self->priv->certificate_change_text_label;
#line 201 "../src/dialogs.vala"
	_tmp1_ = self->priv->connection_name;
#line 201 "../src/dialogs.vala"
	_tmp2_ = g_strdup_printf (_ ("The remote server “%s” certificate doesn't match local copy. It may be" \
" someone's pretending to be the server."), _tmp1_);
#line 201 "../src/dialogs.vala"
	_tmp3_ = _tmp2_;
#line 201 "../src/dialogs.vala"
	gtk_label_set_label (_tmp0_, _tmp3_);
#line 201 "../src/dialogs.vala"
	_g_free0 (_tmp3_);
#line 203 "../src/dialogs.vala"
	_tmp4_ = self->priv->fingerprint_value;
#line 203 "../src/dialogs.vala"
	_tmp5_ = self->priv->certificate_fingerprint;
#line 203 "../src/dialogs.vala"
	_tmp6_ = connections_dialogs_window_split_fingerprint (self, _tmp5_);
#line 203 "../src/dialogs.vala"
	_tmp7_ = _tmp6_;
#line 203 "../src/dialogs.vala"
	gtk_label_set_label (_tmp4_, _tmp7_);
#line 203 "../src/dialogs.vala"
	_g_free0 (_tmp7_);
#line 205 "../src/dialogs.vala"
	g_mutex_unlock (&self->priv->mutex);
#line 207 "../src/dialogs.vala"
	_tmp8_ = self->content_stack;
#line 207 "../src/dialogs.vala"
	gtk_stack_set_visible_child_name (_tmp8_, "certificate-change-verification");
#line 208 "../src/dialogs.vala"
	_tmp9_ = self->header_stack;
#line 208 "../src/dialogs.vala"
	gtk_stack_set_visible_child_name (_tmp9_, "connect-button-page");
#line 209 "../src/dialogs.vala"
	_tmp10_ = self->content_stack;
#line 209 "../src/dialogs.vala"
	gtk_widget_show ((GtkWidget*) _tmp10_);
#line 210 "../src/dialogs.vala"
	_tmp11_ = self->header_stack;
#line 210 "../src/dialogs.vala"
	gtk_widget_show ((GtkWidget*) _tmp11_);
#line 211 "../src/dialogs.vala"
	_tmp12_ = self->priv->dialog_headerbar;
#line 211 "../src/dialogs.vala"
	gtk_widget_show ((GtkWidget*) _tmp12_);
#line 212 "../src/dialogs.vala"
	gtk_window_present ((GtkWindow*) self);
#line 967 "dialogs.c"
}

void
connections_dialogs_window_show_certificate_change_verification (ConnectionsDialogsWindow* self,
                                                                 const gchar* name,
                                                                 const gchar* fingerprint,
                                                                 ConnectionsDialogsWindowCertificateChangeVerifyFunc certificate_change_verify_func_in,
                                                                 gpointer certificate_change_verify_func_in_target,
                                                                 GDestroyNotify certificate_change_verify_func_in_target_destroy_notify)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 216 "../src/dialogs.vala"
	g_return_if_fail (self != NULL);
#line 216 "../src/dialogs.vala"
	g_return_if_fail (name != NULL);
#line 216 "../src/dialogs.vala"
	g_return_if_fail (fingerprint != NULL);
#line 219 "../src/dialogs.vala"
	g_mutex_lock (&self->priv->mutex);
#line 221 "../src/dialogs.vala"
	self->priv->change_verification = TRUE;
#line 222 "../src/dialogs.vala"
	_tmp0_ = g_strdup (name);
#line 222 "../src/dialogs.vala"
	_g_free0 (self->priv->connection_name);
#line 222 "../src/dialogs.vala"
	self->priv->connection_name = _tmp0_;
#line 223 "../src/dialogs.vala"
	_tmp1_ = g_strdup (fingerprint);
#line 223 "../src/dialogs.vala"
	_g_free0 (self->priv->certificate_fingerprint);
#line 223 "../src/dialogs.vala"
	self->priv->certificate_fingerprint = _tmp1_;
#line 224 "../src/dialogs.vala"
	(self->priv->certificate_change_verify_func_target_destroy_notify == NULL) ? NULL : (self->priv->certificate_change_verify_func_target_destroy_notify (self->priv->certificate_change_verify_func_target), NULL);
#line 224 "../src/dialogs.vala"
	self->priv->certificate_change_verify_func = NULL;
#line 224 "../src/dialogs.vala"
	self->priv->certificate_change_verify_func_target = NULL;
#line 224 "../src/dialogs.vala"
	self->priv->certificate_change_verify_func_target_destroy_notify = NULL;
#line 224 "../src/dialogs.vala"
	self->priv->certificate_change_verify_func = certificate_change_verify_func_in;
#line 224 "../src/dialogs.vala"
	self->priv->certificate_change_verify_func_target = certificate_change_verify_func_in_target;
#line 224 "../src/dialogs.vala"
	self->priv->certificate_change_verify_func_target_destroy_notify = NULL;
#line 225 "../src/dialogs.vala"
	self->priv->certificate_change_verification_show_flag = TRUE;
#line 227 "../src/dialogs.vala"
	g_mutex_unlock (&self->priv->mutex);
#line 216 "../src/dialogs.vala"
	(certificate_change_verify_func_in_target_destroy_notify == NULL) ? NULL : (certificate_change_verify_func_in_target_destroy_notify (certificate_change_verify_func_in_target), NULL);
#line 216 "../src/dialogs.vala"
	certificate_change_verify_func_in = NULL;
#line 216 "../src/dialogs.vala"
	certificate_change_verify_func_in_target = NULL;
#line 216 "../src/dialogs.vala"
	certificate_change_verify_func_in_target_destroy_notify = NULL;
#line 1028 "dialogs.c"
}

void
connections_dialogs_window_show_authentication_real (ConnectionsDialogsWindow* self)
{
	HdyActionRow* _tmp0_;
	HdyActionRow* _tmp1_;
	HdyActionRow* _tmp2_;
	GtkLabel* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GtkStack* _tmp7_;
	GtkStack* _tmp8_;
	HdyHeaderBar* _tmp9_;
#line 234 "../src/dialogs.vala"
	g_return_if_fail (self != NULL);
#line 235 "../src/dialogs.vala"
	g_mutex_lock (&self->priv->mutex);
#line 237 "../src/dialogs.vala"
	_tmp0_ = self->priv->username_row;
#line 237 "../src/dialogs.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, self->priv->need_username);
#line 238 "../src/dialogs.vala"
	_tmp1_ = self->priv->password_row;
#line 238 "../src/dialogs.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, self->priv->need_password);
#line 239 "../src/dialogs.vala"
	_tmp2_ = self->priv->domain_row;
#line 239 "../src/dialogs.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp2_, self->priv->need_domain);
#line 241 "../src/dialogs.vala"
	_tmp3_ = self->priv->authentication_text;
#line 241 "../src/dialogs.vala"
	_tmp4_ = self->priv->connection_name;
#line 241 "../src/dialogs.vala"
	_tmp5_ = g_strdup_printf (_ ("The remote server “%s” requires a username and password to continue to" \
" connect."), _tmp4_);
#line 241 "../src/dialogs.vala"
	_tmp6_ = _tmp5_;
#line 241 "../src/dialogs.vala"
	gtk_label_set_label (_tmp3_, _tmp6_);
#line 241 "../src/dialogs.vala"
	_g_free0 (_tmp6_);
#line 243 "../src/dialogs.vala"
	g_mutex_unlock (&self->priv->mutex);
#line 245 "../src/dialogs.vala"
	_tmp7_ = self->content_stack;
#line 245 "../src/dialogs.vala"
	gtk_stack_set_visible_child_name (_tmp7_, "authentication");
#line 246 "../src/dialogs.vala"
	_tmp8_ = self->content_stack;
#line 246 "../src/dialogs.vala"
	gtk_widget_show ((GtkWidget*) _tmp8_);
#line 247 "../src/dialogs.vala"
	_tmp9_ = self->priv->dialog_headerbar;
#line 247 "../src/dialogs.vala"
	gtk_widget_hide ((GtkWidget*) _tmp9_);
#line 248 "../src/dialogs.vala"
	gtk_window_present ((GtkWindow*) self);
#line 1088 "dialogs.c"
}

void
connections_dialogs_window_show_authentication (ConnectionsDialogsWindow* self,
                                                const gchar* name,
                                                gboolean need_username_in,
                                                gboolean need_password_in,
                                                gboolean need_domain_in,
                                                ConnectionsDialogsWindowAuthenticationFunc authentication_func_in,
                                                gpointer authentication_func_in_target,
                                                GDestroyNotify authentication_func_in_target_destroy_notify)
{
	gchar* _tmp0_;
#line 252 "../src/dialogs.vala"
	g_return_if_fail (self != NULL);
#line 252 "../src/dialogs.vala"
	g_return_if_fail (name != NULL);
#line 257 "../src/dialogs.vala"
	g_mutex_lock (&self->priv->mutex);
#line 259 "../src/dialogs.vala"
	self->priv->need_username = need_username_in;
#line 260 "../src/dialogs.vala"
	self->priv->need_password = need_password_in;
#line 261 "../src/dialogs.vala"
	self->priv->need_domain = need_domain_in;
#line 262 "../src/dialogs.vala"
	_tmp0_ = g_strdup (name);
#line 262 "../src/dialogs.vala"
	_g_free0 (self->priv->connection_name);
#line 262 "../src/dialogs.vala"
	self->priv->connection_name = _tmp0_;
#line 263 "../src/dialogs.vala"
	(self->priv->authentication_func_target_destroy_notify == NULL) ? NULL : (self->priv->authentication_func_target_destroy_notify (self->priv->authentication_func_target), NULL);
#line 263 "../src/dialogs.vala"
	self->priv->authentication_func = NULL;
#line 263 "../src/dialogs.vala"
	self->priv->authentication_func_target = NULL;
#line 263 "../src/dialogs.vala"
	self->priv->authentication_func_target_destroy_notify = NULL;
#line 263 "../src/dialogs.vala"
	self->priv->authentication_func = authentication_func_in;
#line 263 "../src/dialogs.vala"
	self->priv->authentication_func_target = authentication_func_in_target;
#line 263 "../src/dialogs.vala"
	self->priv->authentication_func_target_destroy_notify = NULL;
#line 264 "../src/dialogs.vala"
	self->priv->authentication_show_flag = TRUE;
#line 266 "../src/dialogs.vala"
	g_mutex_unlock (&self->priv->mutex);
#line 252 "../src/dialogs.vala"
	(authentication_func_in_target_destroy_notify == NULL) ? NULL : (authentication_func_in_target_destroy_notify (authentication_func_in_target), NULL);
#line 252 "../src/dialogs.vala"
	authentication_func_in = NULL;
#line 252 "../src/dialogs.vala"
	authentication_func_in_target = NULL;
#line 252 "../src/dialogs.vala"
	authentication_func_in_target_destroy_notify = NULL;
#line 1146 "dialogs.c"
}

static void
connections_dialogs_window_cancel_connection (ConnectionsDialogsWindow* self)
{
#line 270 "../src/dialogs.vala"
	g_return_if_fail (self != NULL);
#line 271 "../src/dialogs.vala"
	g_mutex_lock (&self->priv->mutex);
#line 273 "../src/dialogs.vala"
	if (self->priv->change_verification) {
#line 1158 "dialogs.c"
		ConnectionsDialogsWindowCertificateChangeVerifyFunc _tmp0_;
		gpointer _tmp0__target;
#line 274 "../src/dialogs.vala"
		_tmp0_ = self->priv->certificate_change_verify_func;
#line 274 "../src/dialogs.vala"
		_tmp0__target = self->priv->certificate_change_verify_func_target;
#line 274 "../src/dialogs.vala"
		if (_tmp0_ != NULL) {
#line 1167 "dialogs.c"
			ConnectionsDialogsWindowCertificateChangeVerifyFunc _tmp1_;
			gpointer _tmp1__target;
#line 275 "../src/dialogs.vala"
			_tmp1_ = self->priv->certificate_change_verify_func;
#line 275 "../src/dialogs.vala"
			_tmp1__target = self->priv->certificate_change_verify_func_target;
#line 275 "../src/dialogs.vala"
			_tmp1_ (FALSE, _tmp1__target);
#line 1176 "dialogs.c"
		}
	} else {
		ConnectionsDialogsWindowCertificateVerifyFunc _tmp2_;
		gpointer _tmp2__target;
#line 277 "../src/dialogs.vala"
		_tmp2_ = self->priv->certificate_verify_func;
#line 277 "../src/dialogs.vala"
		_tmp2__target = self->priv->certificate_verify_func_target;
#line 277 "../src/dialogs.vala"
		if (_tmp2_ != NULL) {
#line 1187 "dialogs.c"
			ConnectionsDialogsWindowCertificateVerifyFunc _tmp3_;
			gpointer _tmp3__target;
#line 278 "../src/dialogs.vala"
			_tmp3_ = self->priv->certificate_verify_func;
#line 278 "../src/dialogs.vala"
			_tmp3__target = self->priv->certificate_verify_func_target;
#line 278 "../src/dialogs.vala"
			_tmp3_ (FALSE, _tmp3__target);
#line 1196 "dialogs.c"
		}
	}
#line 281 "../src/dialogs.vala"
	g_mutex_unlock (&self->priv->mutex);
#line 283 "../src/dialogs.vala"
	connections_dialogs_window_dismiss (self);
#line 1203 "dialogs.c"
}

static void
_connections_dialogs_window_cancel_connection_gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self)
{
#line 24 "../src/dialogs.vala"
	connections_dialogs_window_cancel_connection ((ConnectionsDialogsWindow*) self);
#line 1212 "dialogs.c"
}

static void
connections_dialogs_window_verify_button_clicked_cb (ConnectionsDialogsWindow* self)
{
#line 287 "../src/dialogs.vala"
	g_return_if_fail (self != NULL);
#line 288 "../src/dialogs.vala"
	g_mutex_lock (&self->priv->mutex);
#line 290 "../src/dialogs.vala"
	if (self->priv->change_verification) {
#line 1224 "dialogs.c"
		ConnectionsDialogsWindowCertificateChangeVerifyFunc _tmp0_;
		gpointer _tmp0__target;
#line 291 "../src/dialogs.vala"
		_tmp0_ = self->priv->certificate_change_verify_func;
#line 291 "../src/dialogs.vala"
		_tmp0__target = self->priv->certificate_change_verify_func_target;
#line 291 "../src/dialogs.vala"
		if (_tmp0_ != NULL) {
#line 1233 "dialogs.c"
			ConnectionsDialogsWindowCertificateChangeVerifyFunc _tmp1_;
			gpointer _tmp1__target;
#line 292 "../src/dialogs.vala"
			_tmp1_ = self->priv->certificate_change_verify_func;
#line 292 "../src/dialogs.vala"
			_tmp1__target = self->priv->certificate_change_verify_func_target;
#line 292 "../src/dialogs.vala"
			_tmp1_ (TRUE, _tmp1__target);
#line 1242 "dialogs.c"
		}
	} else {
		ConnectionsDialogsWindowCertificateVerifyFunc _tmp2_;
		gpointer _tmp2__target;
#line 294 "../src/dialogs.vala"
		_tmp2_ = self->priv->certificate_verify_func;
#line 294 "../src/dialogs.vala"
		_tmp2__target = self->priv->certificate_verify_func_target;
#line 294 "../src/dialogs.vala"
		if (_tmp2_ != NULL) {
#line 1253 "dialogs.c"
			ConnectionsDialogsWindowCertificateVerifyFunc _tmp3_;
			gpointer _tmp3__target;
#line 295 "../src/dialogs.vala"
			_tmp3_ = self->priv->certificate_verify_func;
#line 295 "../src/dialogs.vala"
			_tmp3__target = self->priv->certificate_verify_func_target;
#line 295 "../src/dialogs.vala"
			_tmp3_ (TRUE, _tmp3__target);
#line 1262 "dialogs.c"
		}
	}
#line 298 "../src/dialogs.vala"
	g_mutex_unlock (&self->priv->mutex);
#line 300 "../src/dialogs.vala"
	connections_dialogs_window_dismiss (self);
#line 1269 "dialogs.c"
}

static void
_connections_dialogs_window_verify_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                         gpointer self)
{
#line 24 "../src/dialogs.vala"
	connections_dialogs_window_verify_button_clicked_cb ((ConnectionsDialogsWindow*) self);
#line 1278 "dialogs.c"
}

static void
connections_dialogs_window_connect_button_clicked_cb (ConnectionsDialogsWindow* self)
{
#line 304 "../src/dialogs.vala"
	g_return_if_fail (self != NULL);
#line 305 "../src/dialogs.vala"
	connections_dialogs_window_show_certificate_verification_real (self);
#line 1288 "dialogs.c"
}

static void
_connections_dialogs_window_connect_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                          gpointer self)
{
#line 24 "../src/dialogs.vala"
	connections_dialogs_window_connect_button_clicked_cb ((ConnectionsDialogsWindow*) self);
#line 1297 "dialogs.c"
}

static void
connections_dialogs_window_delete_local_certificate_switch_changed (ConnectionsDialogsWindow* self)
{
	GtkButton* _tmp0_;
	GtkSwitch* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 309 "../src/dialogs.vala"
	g_return_if_fail (self != NULL);
#line 310 "../src/dialogs.vala"
	_tmp0_ = self->priv->connect_button;
#line 310 "../src/dialogs.vala"
	_tmp1_ = self->priv->delete_local_certificate_switch;
#line 310 "../src/dialogs.vala"
	_tmp2_ = gtk_switch_get_active (_tmp1_);
#line 310 "../src/dialogs.vala"
	_tmp3_ = _tmp2_;
#line 310 "../src/dialogs.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, _tmp3_);
#line 1319 "dialogs.c"
}

static void
_connections_dialogs_window_delete_local_certificate_switch_changed_g_object_notify (GObject* _sender,
                                                                                     GParamSpec* pspec,
                                                                                     gpointer self)
{
#line 24 "../src/dialogs.vala"
	connections_dialogs_window_delete_local_certificate_switch_changed ((ConnectionsDialogsWindow*) self);
#line 1329 "dialogs.c"
}

static gboolean
connections_dialogs_window_on_key_pressed (ConnectionsDialogsWindow* self,
                                           GtkWidget* widget,
                                           GdkEventKey* event)
{
	gboolean result;
#line 314 "../src/dialogs.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 314 "../src/dialogs.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 314 "../src/dialogs.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 315 "../src/dialogs.vala"
	if (event->keyval == GDK_KEY_Escape) {
#line 316 "../src/dialogs.vala"
		connections_dialogs_window_cancel_connection (self);
#line 317 "../src/dialogs.vala"
		result = TRUE;
#line 317 "../src/dialogs.vala"
		return result;
#line 1352 "dialogs.c"
	}
#line 320 "../src/dialogs.vala"
	result = FALSE;
#line 320 "../src/dialogs.vala"
	return result;
#line 1358 "dialogs.c"
}

static gboolean
_connections_dialogs_window_on_key_pressed_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                       GdkEventKey* event,
                                                                       gpointer self)
{
	gboolean result;
	result = connections_dialogs_window_on_key_pressed ((ConnectionsDialogsWindow*) self, _sender, event);
#line 24 "../src/dialogs.vala"
	return result;
#line 1370 "dialogs.c"
}

static void
connections_dialogs_window_show_password_button_clicked (ConnectionsDialogsWindow* self)
{
	GtkEntry* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 324 "../src/dialogs.vala"
	g_return_if_fail (self != NULL);
#line 325 "../src/dialogs.vala"
	_tmp0_ = self->priv->password_entry;
#line 325 "../src/dialogs.vala"
	_tmp1_ = gtk_entry_get_visibility (_tmp0_);
#line 325 "../src/dialogs.vala"
	_tmp2_ = _tmp1_;
#line 325 "../src/dialogs.vala"
	if (_tmp2_) {
#line 1389 "dialogs.c"
		GtkImage* _tmp3_;
		GtkEntry* _tmp4_;
#line 326 "../src/dialogs.vala"
		_tmp3_ = self->priv->show_password_icon;
#line 326 "../src/dialogs.vala"
		g_object_set (_tmp3_, "icon-name", "view-reveal-symbolic", NULL);
#line 327 "../src/dialogs.vala"
		_tmp4_ = self->priv->password_entry;
#line 327 "../src/dialogs.vala"
		gtk_entry_set_visibility (_tmp4_, FALSE);
#line 1400 "dialogs.c"
	} else {
		GtkImage* _tmp5_;
		GtkEntry* _tmp6_;
#line 329 "../src/dialogs.vala"
		_tmp5_ = self->priv->show_password_icon;
#line 329 "../src/dialogs.vala"
		g_object_set (_tmp5_, "icon-name", "user-not-tracked-symbolic", NULL);
#line 330 "../src/dialogs.vala"
		_tmp6_ = self->priv->password_entry;
#line 330 "../src/dialogs.vala"
		gtk_entry_set_visibility (_tmp6_, TRUE);
#line 1412 "dialogs.c"
	}
}

static void
_connections_dialogs_window_show_password_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                             gpointer self)
{
#line 24 "../src/dialogs.vala"
	connections_dialogs_window_show_password_button_clicked ((ConnectionsDialogsWindow*) self);
#line 1422 "dialogs.c"
}

static void
connections_dialogs_window_cancel_authentication_clicked (ConnectionsDialogsWindow* self)
{
	ConnectionsDialogsWindowAuthenticationFunc _tmp0_;
	gpointer _tmp0__target;
#line 335 "../src/dialogs.vala"
	g_return_if_fail (self != NULL);
#line 336 "../src/dialogs.vala"
	g_mutex_lock (&self->priv->mutex);
#line 338 "../src/dialogs.vala"
	gtk_widget_hide ((GtkWidget*) self);
#line 340 "../src/dialogs.vala"
	_tmp0_ = self->priv->authentication_func;
#line 340 "../src/dialogs.vala"
	_tmp0__target = self->priv->authentication_func_target;
#line 340 "../src/dialogs.vala"
	if (_tmp0_ != NULL) {
#line 1442 "dialogs.c"
		ConnectionsDialogsWindowAuthenticationFunc _tmp1_;
		gpointer _tmp1__target;
#line 341 "../src/dialogs.vala"
		_tmp1_ = self->priv->authentication_func;
#line 341 "../src/dialogs.vala"
		_tmp1__target = self->priv->authentication_func_target;
#line 341 "../src/dialogs.vala"
		_tmp1_ ("", "", "", _tmp1__target);
#line 342 "../src/dialogs.vala"
		(self->priv->authentication_func_target_destroy_notify == NULL) ? NULL : (self->priv->authentication_func_target_destroy_notify (self->priv->authentication_func_target), NULL);
#line 342 "../src/dialogs.vala"
		self->priv->authentication_func = NULL;
#line 342 "../src/dialogs.vala"
		self->priv->authentication_func_target = NULL;
#line 342 "../src/dialogs.vala"
		self->priv->authentication_func_target_destroy_notify = NULL;
#line 342 "../src/dialogs.vala"
		self->priv->authentication_func = NULL;
#line 342 "../src/dialogs.vala"
		self->priv->authentication_func_target = NULL;
#line 342 "../src/dialogs.vala"
		self->priv->authentication_func_target_destroy_notify = NULL;
#line 1465 "dialogs.c"
	}
#line 345 "../src/dialogs.vala"
	g_mutex_unlock (&self->priv->mutex);
#line 347 "../src/dialogs.vala"
	connections_dialogs_window_dismiss (self);
#line 1471 "dialogs.c"
}

static void
_connections_dialogs_window_cancel_authentication_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                              gpointer self)
{
#line 24 "../src/dialogs.vala"
	connections_dialogs_window_cancel_authentication_clicked ((ConnectionsDialogsWindow*) self);
#line 1480 "dialogs.c"
}

static void
connections_dialogs_window_authenticate_button_clicked (ConnectionsDialogsWindow* self)
{
	ConnectionsDialogsWindowAuthenticationFunc _tmp0_;
	gpointer _tmp0__target;
#line 351 "../src/dialogs.vala"
	g_return_if_fail (self != NULL);
#line 352 "../src/dialogs.vala"
	g_mutex_lock (&self->priv->mutex);
#line 354 "../src/dialogs.vala"
	gtk_widget_hide ((GtkWidget*) self);
#line 356 "../src/dialogs.vala"
	_tmp0_ = self->priv->authentication_func;
#line 356 "../src/dialogs.vala"
	_tmp0__target = self->priv->authentication_func_target;
#line 356 "../src/dialogs.vala"
	if (_tmp0_ != NULL) {
#line 1500 "dialogs.c"
		ConnectionsDialogsWindowAuthenticationFunc _tmp1_;
		gpointer _tmp1__target;
		GtkEntry* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		GtkEntry* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		GtkEntry* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
#line 357 "../src/dialogs.vala"
		_tmp1_ = self->priv->authentication_func;
#line 357 "../src/dialogs.vala"
		_tmp1__target = self->priv->authentication_func_target;
#line 357 "../src/dialogs.vala"
		_tmp2_ = self->priv->username_entry;
#line 357 "../src/dialogs.vala"
		_tmp3_ = gtk_entry_get_text (_tmp2_);
#line 357 "../src/dialogs.vala"
		_tmp4_ = _tmp3_;
#line 357 "../src/dialogs.vala"
		_tmp5_ = self->priv->password_entry;
#line 357 "../src/dialogs.vala"
		_tmp6_ = gtk_entry_get_text (_tmp5_);
#line 357 "../src/dialogs.vala"
		_tmp7_ = _tmp6_;
#line 357 "../src/dialogs.vala"
		_tmp8_ = self->priv->domain_entry;
#line 357 "../src/dialogs.vala"
		_tmp9_ = gtk_entry_get_text (_tmp8_);
#line 357 "../src/dialogs.vala"
		_tmp10_ = _tmp9_;
#line 357 "../src/dialogs.vala"
		_tmp1_ (_tmp4_, _tmp7_, _tmp10_, _tmp1__target);
#line 358 "../src/dialogs.vala"
		(self->priv->authentication_func_target_destroy_notify == NULL) ? NULL : (self->priv->authentication_func_target_destroy_notify (self->priv->authentication_func_target), NULL);
#line 358 "../src/dialogs.vala"
		self->priv->authentication_func = NULL;
#line 358 "../src/dialogs.vala"
		self->priv->authentication_func_target = NULL;
#line 358 "../src/dialogs.vala"
		self->priv->authentication_func_target_destroy_notify = NULL;
#line 358 "../src/dialogs.vala"
		self->priv->authentication_func = NULL;
#line 358 "../src/dialogs.vala"
		self->priv->authentication_func_target = NULL;
#line 358 "../src/dialogs.vala"
		self->priv->authentication_func_target_destroy_notify = NULL;
#line 1550 "dialogs.c"
	}
#line 361 "../src/dialogs.vala"
	g_mutex_unlock (&self->priv->mutex);
#line 363 "../src/dialogs.vala"
	connections_dialogs_window_dismiss (self);
#line 1556 "dialogs.c"
}

static void
_connections_dialogs_window_authenticate_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                            gpointer self)
{
#line 24 "../src/dialogs.vala"
	connections_dialogs_window_authenticate_button_clicked ((ConnectionsDialogsWindow*) self);
#line 1565 "dialogs.c"
}

static void
connections_dialogs_window_on_username_entry_activated (ConnectionsDialogsWindow* self)
{
#line 367 "../src/dialogs.vala"
	g_return_if_fail (self != NULL);
#line 368 "../src/dialogs.vala"
	connections_dialogs_window_authenticate_button_clicked (self);
#line 1575 "dialogs.c"
}

static void
_connections_dialogs_window_on_username_entry_activated_gtk_entry_activate (GtkEntry* _sender,
                                                                            gpointer self)
{
#line 24 "../src/dialogs.vala"
	connections_dialogs_window_on_username_entry_activated ((ConnectionsDialogsWindow*) self);
#line 1584 "dialogs.c"
}

static void
connections_dialogs_window_on_password_entry_activated (ConnectionsDialogsWindow* self)
{
#line 372 "../src/dialogs.vala"
	g_return_if_fail (self != NULL);
#line 373 "../src/dialogs.vala"
	connections_dialogs_window_authenticate_button_clicked (self);
#line 1594 "dialogs.c"
}

static void
_connections_dialogs_window_on_password_entry_activated_gtk_entry_activate (GtkEntry* _sender,
                                                                            gpointer self)
{
#line 24 "../src/dialogs.vala"
	connections_dialogs_window_on_password_entry_activated ((ConnectionsDialogsWindow*) self);
#line 1603 "dialogs.c"
}

static void
connections_dialogs_window_on_domain_entry_activated (ConnectionsDialogsWindow* self)
{
#line 377 "../src/dialogs.vala"
	g_return_if_fail (self != NULL);
#line 378 "../src/dialogs.vala"
	connections_dialogs_window_authenticate_button_clicked (self);
#line 1613 "dialogs.c"
}

static void
_connections_dialogs_window_on_domain_entry_activated_gtk_entry_activate (GtkEntry* _sender,
                                                                          gpointer self)
{
#line 24 "../src/dialogs.vala"
	connections_dialogs_window_on_domain_entry_activated ((ConnectionsDialogsWindow*) self);
#line 1622 "dialogs.c"
}

static void
connections_dialogs_window_dismiss (ConnectionsDialogsWindow* self)
{
	GtkEntry* _tmp0_;
	GtkEntry* _tmp1_;
	GtkEntry* _tmp2_;
	GtkSwitch* _tmp3_;
#line 381 "../src/dialogs.vala"
	g_return_if_fail (self != NULL);
#line 382 "../src/dialogs.vala"
	gtk_widget_hide ((GtkWidget*) self);
#line 383 "../src/dialogs.vala"
	_tmp0_ = self->priv->username_entry;
#line 383 "../src/dialogs.vala"
	gtk_entry_set_text (_tmp0_, "");
#line 384 "../src/dialogs.vala"
	_tmp1_ = self->priv->password_entry;
#line 384 "../src/dialogs.vala"
	gtk_entry_set_text (_tmp1_, "");
#line 385 "../src/dialogs.vala"
	_tmp2_ = self->priv->domain_entry;
#line 385 "../src/dialogs.vala"
	gtk_entry_set_text (_tmp2_, "");
#line 386 "../src/dialogs.vala"
	_tmp3_ = self->priv->delete_local_certificate_switch;
#line 386 "../src/dialogs.vala"
	gtk_switch_set_active (_tmp3_, FALSE);
#line 1652 "dialogs.c"
}

static gboolean
connections_dialogs_window_hide_when_delete (ConnectionsDialogsWindow* self)
{
	gboolean result;
#line 389 "../src/dialogs.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 390 "../src/dialogs.vala"
	connections_dialogs_window_cancel_connection (self);
#line 391 "../src/dialogs.vala"
	result = TRUE;
#line 391 "../src/dialogs.vala"
	return result;
#line 1667 "dialogs.c"
}

ConnectionsDialogsWindow*
connections_dialogs_window_construct (GType object_type)
{
	ConnectionsDialogsWindow * self = NULL;
#line 24 "../src/dialogs.vala"
	self = (ConnectionsDialogsWindow*) g_object_new (object_type, NULL);
#line 24 "../src/dialogs.vala"
	return self;
#line 1678 "dialogs.c"
}

ConnectionsDialogsWindow*
connections_dialogs_window_new (void)
{
#line 24 "../src/dialogs.vala"
	return connections_dialogs_window_construct (CONNECTIONS_TYPE_DIALOGS_WINDOW);
#line 1686 "dialogs.c"
}

static gboolean
_connections_dialogs_window_check_show_flags_gsource_func (gpointer self)
{
	gboolean result;
	result = connections_dialogs_window_check_show_flags ((ConnectionsDialogsWindow*) self);
#line 106 "../src/dialogs.vala"
	return result;
#line 1696 "dialogs.c"
}

static gboolean
_connections_dialogs_window_hide_when_delete_gtk_widget_delete_event (GtkWidget* _sender,
                                                                      GdkEventAny* event,
                                                                      gpointer self)
{
	gboolean result;
	result = connections_dialogs_window_hide_when_delete ((ConnectionsDialogsWindow*) self);
#line 108 "../src/dialogs.vala"
	return result;
#line 1708 "dialogs.c"
}

static GObject *
connections_dialogs_window_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ConnectionsDialogsWindow * self;
	GError* _inner_error0_ = NULL;
#line 85 "../src/dialogs.vala"
	parent_class = G_OBJECT_CLASS (connections_dialogs_window_parent_class);
#line 85 "../src/dialogs.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 85 "../src/dialogs.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONNECTIONS_TYPE_DIALOGS_WINDOW, ConnectionsDialogsWindow);
#line 86 "../src/dialogs.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_START);
#line 87 "../src/dialogs.vala"
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 89 "../src/dialogs.vala"
	self->priv->certificate_verification_show_flag = FALSE;
#line 90 "../src/dialogs.vala"
	self->priv->certificate_change_verification_show_flag = FALSE;
#line 91 "../src/dialogs.vala"
	self->priv->authentication_show_flag = FALSE;
#line 92 "../src/dialogs.vala"
	_vala_clear_GMutex (&self->priv->mutex);
#line 92 "../src/dialogs.vala"
	g_mutex_init (&self->priv->mutex);
#line 1740 "dialogs.c"
	{
		GtkCssProvider* style_provider = NULL;
		GtkCssProvider* _tmp0_;
		gchar* css_style = NULL;
		gchar* _tmp1_;
		GtkCssProvider* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		GdkScreen* _tmp7_;
		GtkCssProvider* _tmp8_;
#line 95 "../src/dialogs.vala"
		_tmp0_ = gtk_css_provider_new ();
#line 95 "../src/dialogs.vala"
		style_provider = _tmp0_;
#line 96 "../src/dialogs.vala"
		_tmp1_ = g_strdup ("button#authenticate_button { border-radius: 0px; border-bottom: 0px; b" \
"order-right: 0px; }\n" \
"                                 button#cancel_button { border-radius:" \
" 0px; border-bottom: 0px; border-left: 0px; border-right: 0px; }");
#line 96 "../src/dialogs.vala"
		css_style = _tmp1_;
#line 98 "../src/dialogs.vala"
		_tmp2_ = style_provider;
#line 98 "../src/dialogs.vala"
		_tmp3_ = css_style;
#line 98 "../src/dialogs.vala"
		_tmp4_ = css_style;
#line 98 "../src/dialogs.vala"
		_tmp5_ = strlen (_tmp4_);
#line 98 "../src/dialogs.vala"
		_tmp6_ = _tmp5_;
#line 98 "../src/dialogs.vala"
		gtk_css_provider_load_from_data (_tmp2_, _tmp3_, (gssize) _tmp6_, &_inner_error0_);
#line 98 "../src/dialogs.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 98 "../src/dialogs.vala"
			_g_free0 (css_style);
#line 98 "../src/dialogs.vala"
			_g_object_unref0 (style_provider);
#line 1779 "dialogs.c"
			goto __catch0_g_error;
		}
#line 99 "../src/dialogs.vala"
		_tmp7_ = gdk_screen_get_default ();
#line 99 "../src/dialogs.vala"
		_tmp8_ = style_provider;
#line 99 "../src/dialogs.vala"
		gtk_style_context_add_provider_for_screen (_tmp7_, (GtkStyleProvider*) _tmp8_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 94 "../src/dialogs.vala"
		_g_free0 (css_style);
#line 94 "../src/dialogs.vala"
		_g_object_unref0 (style_provider);
#line 1792 "dialogs.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 94 "../src/dialogs.vala"
		_error_ = _inner_error0_;
#line 94 "../src/dialogs.vala"
		_inner_error0_ = NULL;
#line 103 "../src/dialogs.vala"
		_tmp9_ = _error_;
#line 103 "../src/dialogs.vala"
		_tmp10_ = _tmp9_->message;
#line 103 "../src/dialogs.vala"
		g_warning ("dialogs.vala:103: Failed to load CSS: %s", _tmp10_);
#line 94 "../src/dialogs.vala"
		_g_error_free0 (_error_);
#line 1812 "dialogs.c"
	}
	__finally0:
#line 94 "../src/dialogs.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 94 "../src/dialogs.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 94 "../src/dialogs.vala"
		g_clear_error (&_inner_error0_);
#line 1821 "dialogs.c"
	}
#line 106 "../src/dialogs.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 50, _connections_dialogs_window_check_show_flags_gsource_func, g_object_ref (self), g_object_unref);
#line 108 "../src/dialogs.vala"
	g_signal_connect_object ((GtkWidget*) self, "delete-event", (GCallback) _connections_dialogs_window_hide_when_delete_gtk_widget_delete_event, self, 0);
#line 85 "../src/dialogs.vala"
	return obj;
#line 1829 "dialogs.c"
}

static void
connections_dialogs_window_class_init (ConnectionsDialogsWindowClass * klass,
                                       gpointer klass_data)
{
#line 24 "../src/dialogs.vala"
	connections_dialogs_window_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/dialogs.vala"
	g_type_class_adjust_private_offset (klass, &ConnectionsDialogsWindow_private_offset);
#line 24 "../src/dialogs.vala"
	G_OBJECT_CLASS (klass)->constructor = connections_dialogs_window_constructor;
#line 24 "../src/dialogs.vala"
	G_OBJECT_CLASS (klass)->finalize = connections_dialogs_window_finalize;
#line 24 "../src/dialogs.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Connections/ui/dialog.ui");
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "content_stack", FALSE, G_STRUCT_OFFSET (ConnectionsDialogsWindow, content_stack));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "header_stack", FALSE, G_STRUCT_OFFSET (ConnectionsDialogsWindow, header_stack));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "text_label", FALSE, ConnectionsDialogsWindow_private_offset + G_STRUCT_OFFSET (ConnectionsDialogsWindowPrivate, text_label));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "fingerprint_value", FALSE, ConnectionsDialogsWindow_private_offset + G_STRUCT_OFFSET (ConnectionsDialogsWindowPrivate, fingerprint_value));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "certificate_change_text_label", FALSE, ConnectionsDialogsWindow_private_offset + G_STRUCT_OFFSET (ConnectionsDialogsWindowPrivate, certificate_change_text_label));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "connect_button", FALSE, ConnectionsDialogsWindow_private_offset + G_STRUCT_OFFSET (ConnectionsDialogsWindowPrivate, connect_button));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "delete_local_certificate_switch", FALSE, ConnectionsDialogsWindow_private_offset + G_STRUCT_OFFSET (ConnectionsDialogsWindowPrivate, delete_local_certificate_switch));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "show_password_icon", FALSE, ConnectionsDialogsWindow_private_offset + G_STRUCT_OFFSET (ConnectionsDialogsWindowPrivate, show_password_icon));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "username_entry", FALSE, ConnectionsDialogsWindow_private_offset + G_STRUCT_OFFSET (ConnectionsDialogsWindowPrivate, username_entry));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "password_entry", FALSE, ConnectionsDialogsWindow_private_offset + G_STRUCT_OFFSET (ConnectionsDialogsWindowPrivate, password_entry));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "domain_entry", FALSE, ConnectionsDialogsWindow_private_offset + G_STRUCT_OFFSET (ConnectionsDialogsWindowPrivate, domain_entry));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "authentication_text", FALSE, ConnectionsDialogsWindow_private_offset + G_STRUCT_OFFSET (ConnectionsDialogsWindowPrivate, authentication_text));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "dialog_headerbar", FALSE, ConnectionsDialogsWindow_private_offset + G_STRUCT_OFFSET (ConnectionsDialogsWindowPrivate, dialog_headerbar));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "username_row", FALSE, ConnectionsDialogsWindow_private_offset + G_STRUCT_OFFSET (ConnectionsDialogsWindowPrivate, username_row));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "password_row", FALSE, ConnectionsDialogsWindow_private_offset + G_STRUCT_OFFSET (ConnectionsDialogsWindowPrivate, password_row));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "domain_row", FALSE, ConnectionsDialogsWindow_private_offset + G_STRUCT_OFFSET (ConnectionsDialogsWindowPrivate, domain_row));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "cancel_connection", G_CALLBACK(_connections_dialogs_window_cancel_connection_gtk_button_clicked));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "verify_button_clicked_cb", G_CALLBACK(_connections_dialogs_window_verify_button_clicked_cb_gtk_button_clicked));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "connect_button_clicked_cb", G_CALLBACK(_connections_dialogs_window_connect_button_clicked_cb_gtk_button_clicked));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "delete_local_certificate_switch_changed", G_CALLBACK(_connections_dialogs_window_delete_local_certificate_switch_changed_g_object_notify));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_key_pressed", G_CALLBACK(_connections_dialogs_window_on_key_pressed_gtk_widget_key_press_event));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "show_password_button_clicked", G_CALLBACK(_connections_dialogs_window_show_password_button_clicked_gtk_button_clicked));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "cancel_authentication_clicked", G_CALLBACK(_connections_dialogs_window_cancel_authentication_clicked_gtk_button_clicked));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "authenticate_button_clicked", G_CALLBACK(_connections_dialogs_window_authenticate_button_clicked_gtk_button_clicked));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_username_entry_activated", G_CALLBACK(_connections_dialogs_window_on_username_entry_activated_gtk_entry_activate));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_password_entry_activated", G_CALLBACK(_connections_dialogs_window_on_password_entry_activated_gtk_entry_activate));
#line 24 "../src/dialogs.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_domain_entry_activated", G_CALLBACK(_connections_dialogs_window_on_domain_entry_activated_gtk_entry_activate));
#line 1900 "dialogs.c"
}

static void
connections_dialogs_window_instance_init (ConnectionsDialogsWindow * self,
                                          gpointer klass)
{
#line 24 "../src/dialogs.vala"
	self->priv = connections_dialogs_window_get_instance_private (self);
#line 24 "../src/dialogs.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1911 "dialogs.c"
}

static void
connections_dialogs_window_finalize (GObject * obj)
{
	ConnectionsDialogsWindow * self;
#line 24 "../src/dialogs.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONNECTIONS_TYPE_DIALOGS_WINDOW, ConnectionsDialogsWindow);
#line 26 "../src/dialogs.vala"
	_g_free0 (self->priv->certificate_fingerprint);
#line 27 "../src/dialogs.vala"
	_g_free0 (self->priv->connection_name);
#line 83 "../src/dialogs.vala"
	_vala_clear_GMutex (&self->priv->mutex);
#line 162 "../src/dialogs.vala"
	(self->priv->certificate_verify_func_target_destroy_notify == NULL) ? NULL : (self->priv->certificate_verify_func_target_destroy_notify (self->priv->certificate_verify_func_target), NULL);
#line 162 "../src/dialogs.vala"
	self->priv->certificate_verify_func = NULL;
#line 162 "../src/dialogs.vala"
	self->priv->certificate_verify_func_target = NULL;
#line 162 "../src/dialogs.vala"
	self->priv->certificate_verify_func_target_destroy_notify = NULL;
#line 197 "../src/dialogs.vala"
	(self->priv->certificate_change_verify_func_target_destroy_notify == NULL) ? NULL : (self->priv->certificate_change_verify_func_target_destroy_notify (self->priv->certificate_change_verify_func_target), NULL);
#line 197 "../src/dialogs.vala"
	self->priv->certificate_change_verify_func = NULL;
#line 197 "../src/dialogs.vala"
	self->priv->certificate_change_verify_func_target = NULL;
#line 197 "../src/dialogs.vala"
	self->priv->certificate_change_verify_func_target_destroy_notify = NULL;
#line 233 "../src/dialogs.vala"
	(self->priv->authentication_func_target_destroy_notify == NULL) ? NULL : (self->priv->authentication_func_target_destroy_notify (self->priv->authentication_func_target), NULL);
#line 233 "../src/dialogs.vala"
	self->priv->authentication_func = NULL;
#line 233 "../src/dialogs.vala"
	self->priv->authentication_func_target = NULL;
#line 233 "../src/dialogs.vala"
	self->priv->authentication_func_target_destroy_notify = NULL;
#line 24 "../src/dialogs.vala"
	G_OBJECT_CLASS (connections_dialogs_window_parent_class)->finalize (obj);
#line 1952 "dialogs.c"
}

static GType
connections_dialogs_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ConnectionsDialogsWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) connections_dialogs_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ConnectionsDialogsWindow), 0, (GInstanceInitFunc) connections_dialogs_window_instance_init, NULL };
	GType connections_dialogs_window_type_id;
	connections_dialogs_window_type_id = g_type_register_static (hdy_window_get_type (), "ConnectionsDialogsWindow", &g_define_type_info, 0);
	ConnectionsDialogsWindow_private_offset = g_type_add_instance_private (connections_dialogs_window_type_id, sizeof (ConnectionsDialogsWindowPrivate));
	return connections_dialogs_window_type_id;
}

GType
connections_dialogs_window_get_type (void)
{
	static volatile gsize connections_dialogs_window_type_id__once = 0;
	if (g_once_init_enter (&connections_dialogs_window_type_id__once)) {
		GType connections_dialogs_window_type_id;
		connections_dialogs_window_type_id = connections_dialogs_window_get_type_once ();
		g_once_init_leave (&connections_dialogs_window_type_id__once, connections_dialogs_window_type_id);
	}
	return connections_dialogs_window_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static void
_vala_clear_GMutex (GMutex * mutex)
{
	GMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GMutex))) {
		g_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GMutex));
	}
}

static void
_vala_clear_GRecMutex (GRecMutex * mutex)
{
	GRecMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRecMutex))) {
		g_rec_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GRecMutex));
	}
}

static void
_vala_clear_GRWLock (GRWLock * mutex)
{
	GRWLock zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRWLock))) {
		g_rw_lock_clear (mutex);
		memset (mutex, 0, sizeof (GRWLock));
	}
}

static void
_vala_clear_GCond (GCond * mutex)
{
	GCond zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GCond))) {
		g_cond_clear (mutex);
		memset (mutex, 0, sizeof (GCond));
	}
}

